Status: In Progress Start date: 15 Mar 2018

Priority: Normal Due date:  

Assignee:  % Done: 40%

Category: Data Structures Estimated time: 8.00 hours

Target version: CoCoALib-0.99900 Spent time: 5.50 hours

Description

To be able to call this

const SparsePolyRingBase::IdealImpl* const ptrI =

      SparsePolyRingBase::IdealImpl::ourGetPtr(I);

many functions need to be //friend//.

Can we make this public?

Or is it too dangerous?

History

#1 - 15 Mar 2018 14:12 - John Abbott

- Status changed from New to In Progress

- % Done changed from 0 to 10

If many functions have to be friend that is not a good sign.

I'm too busy to think about it now, so suggest making it public with a comment that this is makeshift solution that has to be properly considered at

some point in the future.

#2 - 17 Mar 2018 09:15 - Anna Maria Bigatti

- % Done changed from 10 to 40

- Estimated time set to 8.00 h

After discussing with John, I made it public.

Indeed the rest of the code is clenear, i.e. we do not need so many friend functions, so the new files SparsePolyOps-ideal/involutive.H make take the

heavy content of SparsePolyRing.H.

On the bad side, this exposes an implementation detail (the pointer) and this, says John, shows that the design is not quite correct.

#3 - 29 Mar 2018 23:03 - Anna Maria Bigatti

It is very convenient having it public :-) :-)

... but today I used it to set the radical/maximal/... flags at the end of the function IdealOfPoints and I didn't need to make it friend.

Convenient, but dangerous.

#4 - 03 Jul 2023 17:49 - John Abbott

- Target version changed from CoCoALib-1.0 to CoCoALib-0.99850
#5 - 08 Mar 2024 17:26 - Anna Maria Bigatti

- Target version changed from CoCoALib-0.99850 to CoCoALib-0.99900
